#!/usr/bin/env python

import sys
import struct
import socket
import select
import threading
import textwrap

port = 9999
buffer_size = 1024
internal = False
should_quit=False

if internal:
  dst_addr = '127.0.0.1'
  bind_addr = '127.0.0.1'
else:
#  dst_addr = '192.168.0.5'
#  bind_addr = '192.168.0.100'
  dst_addr = '134.79.64.51'
  bind_addr = '134.79.64.77'

msg_format = '!4B'
msgs = {
  's': struct.pack(msg_format, 1, 1, 0x02, 0), # short message
  'l': struct.pack(msg_format, 1, 1, 0x48, 0), # long message
}

def receiver(sock):
  s = sock
#  s.settimeout(2.0)
  while True:
    try:
      sys.stdout.flush()
      (rlist, wlist, xlist)=select.select([s],[],[],1.0)
    except:
      break
    if rlist :
      try:
        (data, address) = s.recvfrom(buffer_size)
      except:
        break
    else: continue

    print 'Recv from %s' % address[0]
    for b in data:
      print '0x%x' % ord(b)

    sys.stdout.flush()

  s.close()
  print 'Receive thread finished'

def main():
  print textwrap.dedent(
    '''
    q    quit
    l    send long message
    s    send short message (default)
    '''
  )
  sys.stdout.flush()
  try:
    s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    s.setblocking(False)    
    s.bind((bind_addr, port))
    recv_thread = threading.Thread(target=receiver, args=(s,))    
    recv_thread.start()
    dest = (dst_addr, port)
    while True:
      inp = sys.stdin.readline()
            
      if inp[0] == 'q':
        should_quit = True
        break
      message = msgs.get(inp[0]) or msgs['s']
      idat=struct.unpack('I',message)
      (b0,b1,b2,b3)=struct.unpack('bbbb',message)
      print 'Send: %x %x %x %x' % (b0,b1,b2,b3)
      sys.stdout.flush()
      s.sendto(message, dest)
  finally:
    print 'Finally close socket'
    s.close()

  recv_thread.join()

if __name__ == '__main__':
  main()
